/**
 * <copyright>
 * </copyright>
 *
 * $Id: XmadslCompositeImpl.java 8168 2011-07-15 13:26:44Z hoenninger $
 */
package org.openxma.dsl.pom.model.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.openxma.dsl.core.model.BoolLiteral;
import org.openxma.dsl.pom.PomPackage;
import org.openxma.dsl.pom.model.FieldFlag;
import org.openxma.dsl.pom.model.IDummy;
import org.openxma.dsl.pom.model.IElementWithLayoutData;
import org.openxma.dsl.pom.model.LabelText;
import org.openxma.dsl.pom.model.LayoutDataProperty;
import org.openxma.dsl.pom.model.TabableFlag;
import org.openxma.dsl.pom.model.XmadslComposite;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Xmadsl Composite</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslCompositeImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslCompositeImpl#getLayoutProperties <em>Layout Properties</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslCompositeImpl#getFieldFlags <em>Field Flags</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslCompositeImpl#getTabableFlag <em>Tabable Flag</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslCompositeImpl#getLabelText <em>Label Text</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslCompositeImpl#getScrollable <em>Scrollable</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslCompositeImpl#isHorizontalPartitioning <em>Horizontal Partitioning</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslCompositeImpl#isVerticalPartitioning <em>Vertical Partitioning</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class XmadslCompositeImpl extends ICompositeImpl implements XmadslComposite {
	/**
     * The default value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getName()
     * @generated
     * @ordered
     */
	protected static final String NAME_EDEFAULT = null;

	/**
     * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getName()
     * @generated
     * @ordered
     */
	protected String name = NAME_EDEFAULT;

	/**
     * The cached value of the '{@link #getLayoutProperties() <em>Layout Properties</em>}' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getLayoutProperties()
     * @generated
     * @ordered
     */
	protected EList<LayoutDataProperty> layoutProperties;

	/**
     * The cached value of the '{@link #getFieldFlags() <em>Field Flags</em>}' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getFieldFlags()
     * @generated
     * @ordered
     */
	protected EList<FieldFlag> fieldFlags;

	/**
     * The cached value of the '{@link #getTabableFlag() <em>Tabable Flag</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getTabableFlag()
     * @generated
     * @ordered
     */
    protected TabableFlag tabableFlag;

    /**
     * The cached value of the '{@link #getLabelText() <em>Label Text</em>}' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getLabelText()
     * @generated
     * @ordered
     */
	protected LabelText labelText;

	/**
     * The cached value of the '{@link #getScrollable() <em>Scrollable</em>}' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getScrollable()
     * @generated
     * @ordered
     */
	protected BoolLiteral scrollable;

	/**
     * The default value of the '{@link #isHorizontalPartitioning() <em>Horizontal Partitioning</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #isHorizontalPartitioning()
     * @generated
     * @ordered
     */
	protected static final boolean HORIZONTAL_PARTITIONING_EDEFAULT = false;

	/**
     * The cached value of the '{@link #isHorizontalPartitioning() <em>Horizontal Partitioning</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #isHorizontalPartitioning()
     * @generated
     * @ordered
     */
	protected boolean horizontalPartitioning = HORIZONTAL_PARTITIONING_EDEFAULT;

	/**
     * The default value of the '{@link #isVerticalPartitioning() <em>Vertical Partitioning</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #isVerticalPartitioning()
     * @generated
     * @ordered
     */
	protected static final boolean VERTICAL_PARTITIONING_EDEFAULT = false;

	/**
     * The cached value of the '{@link #isVerticalPartitioning() <em>Vertical Partitioning</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #isVerticalPartitioning()
     * @generated
     * @ordered
     */
	protected boolean verticalPartitioning = VERTICAL_PARTITIONING_EDEFAULT;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected XmadslCompositeImpl() {
        super();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	protected EClass eStaticClass() {
        return PomPackage.Literals.XMADSL_COMPOSITE;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getName() {
        return name;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setName(String newName) {
        String oldName = name;
        name = newName;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_COMPOSITE__NAME, oldName, name));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public BoolLiteral getScrollable() {
        return scrollable;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain basicSetScrollable(BoolLiteral newScrollable, NotificationChain msgs) {
        BoolLiteral oldScrollable = scrollable;
        scrollable = newScrollable;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_COMPOSITE__SCROLLABLE, oldScrollable, newScrollable);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setScrollable(BoolLiteral newScrollable) {
        if (newScrollable != scrollable) {
            NotificationChain msgs = null;
            if (scrollable != null)
                msgs = ((InternalEObject)scrollable).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.XMADSL_COMPOSITE__SCROLLABLE, null, msgs);
            if (newScrollable != null)
                msgs = ((InternalEObject)newScrollable).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.XMADSL_COMPOSITE__SCROLLABLE, null, msgs);
            msgs = basicSetScrollable(newScrollable, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_COMPOSITE__SCROLLABLE, newScrollable, newScrollable));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public LabelText getLabelText() {
        return labelText;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain basicSetLabelText(LabelText newLabelText, NotificationChain msgs) {
        LabelText oldLabelText = labelText;
        labelText = newLabelText;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_COMPOSITE__LABEL_TEXT, oldLabelText, newLabelText);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setLabelText(LabelText newLabelText) {
        if (newLabelText != labelText) {
            NotificationChain msgs = null;
            if (labelText != null)
                msgs = ((InternalEObject)labelText).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.XMADSL_COMPOSITE__LABEL_TEXT, null, msgs);
            if (newLabelText != null)
                msgs = ((InternalEObject)newLabelText).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.XMADSL_COMPOSITE__LABEL_TEXT, null, msgs);
            msgs = basicSetLabelText(newLabelText, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_COMPOSITE__LABEL_TEXT, newLabelText, newLabelText));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<LayoutDataProperty> getLayoutProperties() {
        if (layoutProperties == null) {
            layoutProperties = new EObjectContainmentEList<LayoutDataProperty>(LayoutDataProperty.class, this, PomPackage.XMADSL_COMPOSITE__LAYOUT_PROPERTIES);
        }
        return layoutProperties;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public boolean isVerticalPartitioning() {
        return verticalPartitioning;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setVerticalPartitioning(boolean newVerticalPartitioning) {
        boolean oldVerticalPartitioning = verticalPartitioning;
        verticalPartitioning = newVerticalPartitioning;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_COMPOSITE__VERTICAL_PARTITIONING, oldVerticalPartitioning, verticalPartitioning));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public boolean isHorizontalPartitioning() {
        return horizontalPartitioning;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setHorizontalPartitioning(boolean newHorizontalPartitioning) {
        boolean oldHorizontalPartitioning = horizontalPartitioning;
        horizontalPartitioning = newHorizontalPartitioning;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_COMPOSITE__HORIZONTAL_PARTITIONING, oldHorizontalPartitioning, horizontalPartitioning));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<FieldFlag> getFieldFlags() {
        if (fieldFlags == null) {
            fieldFlags = new EObjectContainmentEList<FieldFlag>(FieldFlag.class, this, PomPackage.XMADSL_COMPOSITE__FIELD_FLAGS);
        }
        return fieldFlags;
    }

	/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public TabableFlag getTabableFlag() {
        return tabableFlag;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetTabableFlag(TabableFlag newTabableFlag, NotificationChain msgs) {
        TabableFlag oldTabableFlag = tabableFlag;
        tabableFlag = newTabableFlag;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_COMPOSITE__TABABLE_FLAG, oldTabableFlag, newTabableFlag);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setTabableFlag(TabableFlag newTabableFlag) {
        if (newTabableFlag != tabableFlag) {
            NotificationChain msgs = null;
            if (tabableFlag != null)
                msgs = ((InternalEObject)tabableFlag).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.XMADSL_COMPOSITE__TABABLE_FLAG, null, msgs);
            if (newTabableFlag != null)
                msgs = ((InternalEObject)newTabableFlag).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.XMADSL_COMPOSITE__TABABLE_FLAG, null, msgs);
            msgs = basicSetTabableFlag(newTabableFlag, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_COMPOSITE__TABABLE_FLAG, newTabableFlag, newTabableFlag));
    }

    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case PomPackage.XMADSL_COMPOSITE__LAYOUT_PROPERTIES:
                return ((InternalEList<?>)getLayoutProperties()).basicRemove(otherEnd, msgs);
            case PomPackage.XMADSL_COMPOSITE__FIELD_FLAGS:
                return ((InternalEList<?>)getFieldFlags()).basicRemove(otherEnd, msgs);
            case PomPackage.XMADSL_COMPOSITE__TABABLE_FLAG:
                return basicSetTabableFlag(null, msgs);
            case PomPackage.XMADSL_COMPOSITE__LABEL_TEXT:
                return basicSetLabelText(null, msgs);
            case PomPackage.XMADSL_COMPOSITE__SCROLLABLE:
                return basicSetScrollable(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case PomPackage.XMADSL_COMPOSITE__NAME:
                return getName();
            case PomPackage.XMADSL_COMPOSITE__LAYOUT_PROPERTIES:
                return getLayoutProperties();
            case PomPackage.XMADSL_COMPOSITE__FIELD_FLAGS:
                return getFieldFlags();
            case PomPackage.XMADSL_COMPOSITE__TABABLE_FLAG:
                return getTabableFlag();
            case PomPackage.XMADSL_COMPOSITE__LABEL_TEXT:
                return getLabelText();
            case PomPackage.XMADSL_COMPOSITE__SCROLLABLE:
                return getScrollable();
            case PomPackage.XMADSL_COMPOSITE__HORIZONTAL_PARTITIONING:
                return isHorizontalPartitioning();
            case PomPackage.XMADSL_COMPOSITE__VERTICAL_PARTITIONING:
                return isVerticalPartitioning();
        }
        return super.eGet(featureID, resolve, coreType);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case PomPackage.XMADSL_COMPOSITE__NAME:
                setName((String)newValue);
                return;
            case PomPackage.XMADSL_COMPOSITE__LAYOUT_PROPERTIES:
                getLayoutProperties().clear();
                getLayoutProperties().addAll((Collection<? extends LayoutDataProperty>)newValue);
                return;
            case PomPackage.XMADSL_COMPOSITE__FIELD_FLAGS:
                getFieldFlags().clear();
                getFieldFlags().addAll((Collection<? extends FieldFlag>)newValue);
                return;
            case PomPackage.XMADSL_COMPOSITE__TABABLE_FLAG:
                setTabableFlag((TabableFlag)newValue);
                return;
            case PomPackage.XMADSL_COMPOSITE__LABEL_TEXT:
                setLabelText((LabelText)newValue);
                return;
            case PomPackage.XMADSL_COMPOSITE__SCROLLABLE:
                setScrollable((BoolLiteral)newValue);
                return;
            case PomPackage.XMADSL_COMPOSITE__HORIZONTAL_PARTITIONING:
                setHorizontalPartitioning((Boolean)newValue);
                return;
            case PomPackage.XMADSL_COMPOSITE__VERTICAL_PARTITIONING:
                setVerticalPartitioning((Boolean)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public void eUnset(int featureID) {
        switch (featureID) {
            case PomPackage.XMADSL_COMPOSITE__NAME:
                setName(NAME_EDEFAULT);
                return;
            case PomPackage.XMADSL_COMPOSITE__LAYOUT_PROPERTIES:
                getLayoutProperties().clear();
                return;
            case PomPackage.XMADSL_COMPOSITE__FIELD_FLAGS:
                getFieldFlags().clear();
                return;
            case PomPackage.XMADSL_COMPOSITE__TABABLE_FLAG:
                setTabableFlag((TabableFlag)null);
                return;
            case PomPackage.XMADSL_COMPOSITE__LABEL_TEXT:
                setLabelText((LabelText)null);
                return;
            case PomPackage.XMADSL_COMPOSITE__SCROLLABLE:
                setScrollable((BoolLiteral)null);
                return;
            case PomPackage.XMADSL_COMPOSITE__HORIZONTAL_PARTITIONING:
                setHorizontalPartitioning(HORIZONTAL_PARTITIONING_EDEFAULT);
                return;
            case PomPackage.XMADSL_COMPOSITE__VERTICAL_PARTITIONING:
                setVerticalPartitioning(VERTICAL_PARTITIONING_EDEFAULT);
                return;
        }
        super.eUnset(featureID);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public boolean eIsSet(int featureID) {
        switch (featureID) {
            case PomPackage.XMADSL_COMPOSITE__NAME:
                return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
            case PomPackage.XMADSL_COMPOSITE__LAYOUT_PROPERTIES:
                return layoutProperties != null && !layoutProperties.isEmpty();
            case PomPackage.XMADSL_COMPOSITE__FIELD_FLAGS:
                return fieldFlags != null && !fieldFlags.isEmpty();
            case PomPackage.XMADSL_COMPOSITE__TABABLE_FLAG:
                return tabableFlag != null;
            case PomPackage.XMADSL_COMPOSITE__LABEL_TEXT:
                return labelText != null;
            case PomPackage.XMADSL_COMPOSITE__SCROLLABLE:
                return scrollable != null;
            case PomPackage.XMADSL_COMPOSITE__HORIZONTAL_PARTITIONING:
                return horizontalPartitioning != HORIZONTAL_PARTITIONING_EDEFAULT;
            case PomPackage.XMADSL_COMPOSITE__VERTICAL_PARTITIONING:
                return verticalPartitioning != VERTICAL_PARTITIONING_EDEFAULT;
        }
        return super.eIsSet(featureID);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
        if (baseClass == IDummy.class) {
            switch (derivedFeatureID) {
                case PomPackage.XMADSL_COMPOSITE__NAME: return PomPackage.IDUMMY__NAME;
                default: return -1;
            }
        }
        if (baseClass == IElementWithLayoutData.class) {
            switch (derivedFeatureID) {
                case PomPackage.XMADSL_COMPOSITE__LAYOUT_PROPERTIES: return PomPackage.IELEMENT_WITH_LAYOUT_DATA__LAYOUT_PROPERTIES;
                case PomPackage.XMADSL_COMPOSITE__FIELD_FLAGS: return PomPackage.IELEMENT_WITH_LAYOUT_DATA__FIELD_FLAGS;
                case PomPackage.XMADSL_COMPOSITE__TABABLE_FLAG: return PomPackage.IELEMENT_WITH_LAYOUT_DATA__TABABLE_FLAG;
                default: return -1;
            }
        }
        return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
        if (baseClass == IDummy.class) {
            switch (baseFeatureID) {
                case PomPackage.IDUMMY__NAME: return PomPackage.XMADSL_COMPOSITE__NAME;
                default: return -1;
            }
        }
        if (baseClass == IElementWithLayoutData.class) {
            switch (baseFeatureID) {
                case PomPackage.IELEMENT_WITH_LAYOUT_DATA__LAYOUT_PROPERTIES: return PomPackage.XMADSL_COMPOSITE__LAYOUT_PROPERTIES;
                case PomPackage.IELEMENT_WITH_LAYOUT_DATA__FIELD_FLAGS: return PomPackage.XMADSL_COMPOSITE__FIELD_FLAGS;
                case PomPackage.IELEMENT_WITH_LAYOUT_DATA__TABABLE_FLAG: return PomPackage.XMADSL_COMPOSITE__TABABLE_FLAG;
                default: return -1;
            }
        }
        return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public String toString() {
        if (eIsProxy()) return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (name: ");
        result.append(name);
        result.append(", horizontalPartitioning: ");
        result.append(horizontalPartitioning);
        result.append(", verticalPartitioning: ");
        result.append(verticalPartitioning);
        result.append(')');
        return result.toString();
    }

} //XmadslCompositeImpl
